/*
IIS 4.0 SHOWCODE.ASP VULNERABILITY TESTER - Checks for the l0pht advisory:

-------------
URL Origin:    http://www.l0pht.com/advisories.html 
Release Date:  May 7th, 1999 
Application:   Microsoft IIS 4.0 Web Server
Severity:      Web users can view ASP source code and other sensitive
               files on the web server 
Author:        weld@l0pht.com 
Operating Sys: Microsoft NT Server 4.0

-------------



This program was built up from the cold fusion scanner written by hypoclear
of lUSt - Linux Users Strike Today..., which copied blatently code from the cgi scanner
written by su1d sh311..

To make a short story shorter:

re-bulit, modified, darted, mungded and played with, by Jack-Smiley from independed ticket-salesmen in Copenhagen.

You can now scan multiple hosts......

compile:   gcc -o showcode showcode.c
usage:     showcode [-m] host
       (-m (multiple) specifies subnet scan. Scans all CERT's Class C of host.)
tested on: Linux  (this should compile on most *NIX systems though)



*/

#include "showcode.h"

const char* HTTP_COMMAND = "GET /msadc/Samples/SELECTOR/showcode.asp HTTP/1.0\n\n";
const char* EXPLOIT_FILE = "showcode.asp";
int         TIMEOUT      = 5;
int         START        = 1;
int         STOP         = 255;
char*       destdotaddr  = "127.0.0.1";
boolean     connection   = true;

int     socket_descriptor;
struct  sockaddr_in s_in;
char*   inet_ntoa();

/***************************************************************************
 *                               MAIN                                      *
 ***************************************************************************/

void main(int argc, char *argv[]){
  char* host_name      = NULL;
  int multiple = false;
  struct hostent* ptr_hostent = NULL;

  if(!parseArgs(argc, argv, &multiple, host_name)){
    printf("\nUsage: %s [-m] host\n",argv[0]);
    printf("-m (multiple) specifies subnet scan. Scans all CERT's Class C of host.\n");
    exit(0);
  }
  if(multiple){
    if((ptr_hostent=gethostbyname(argv[2])) == NULL){
      herror("gethostbyname");
      exit(0);
    }
    if(!multipleScan(ptr_hostent)){
       printf("\nMultiple scan failure\n");
    }
  }else{
    if((ptr_hostent=gethostbyname(argv[1])) == NULL){
      herror("gethostbyname");
      exit(0);
    }
    if(singleScan(ptr_hostent)){
     printf( "\nFound possible exploit at host: %s\n",ptr_hostent->h_name);
    }else if(connection){
     printf("\nNot vurnable....");
    }
  }
  exit(0);
}

/***************************************************************************
 *                          PARSE ARGS                                     *
 ***************************************************************************/

boolean parseArgs(int nr_of_args, char** args,int* multiple, char* host_name){
  if(nr_of_args>3||nr_of_args<2) return false;
  if(nr_of_args == 3){
    *multiple = true;
  }
  if((*multiple)){
    if(args[1][0] != '-' || args[1][1] != 'm') return false;
    printf("\n-=MULTIPE SCAN FOR IIS 4.0 SHOWCODE.ASP VULNERABILITY EXPLOIT=-\n");
  }else{
    printf("\n-=SINGLE SCAN FOR IIS 4.0 SHOWCODE.ASP VULNERABILITY EXPLOIT=-\n");
  }
  return true;
}

/***************************************************************************
 *                          MULTIPLE SCAN                                  *
 ***************************************************************************/

boolean multipleScan(struct hostent* ptr_hostent){
  int     str_length          = 0;
  boolean str_search          = true;
  int     str_token_index     = 0;
  int     ii                  = 0;
  char    new_destdotaddr[256] = {'\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'};

  memset((char*) &s_in,0,sizeof(s_in));
  memset((char*)&destdotaddr,0,sizeof(destdotaddr));
  memcpy(&s_in.sin_addr,ptr_hostent->h_addr,ptr_hostent->h_length);
  s_in.sin_family=AF_INET;
  s_in.sin_port=htons(80);

  destdotaddr = inet_ntoa(s_in.sin_addr);
  str_length  = strlen(destdotaddr);
  while((str_search && (str_length!=0))){
    if(destdotaddr[--str_length]=='.'){
      str_token_index = str_length;
      str_search = false;
    }
  }

  strncpy(new_destdotaddr,destdotaddr,str_token_index +1); // Hate!

  for(ii=START;ii<STOP;ii++){
    sprintf(destdotaddr,"%s%i",new_destdotaddr,ii);
    if((ptr_hostent=gethostbyname(destdotaddr)) == NULL){
      herror("gethostbyname");
    }else{
      if(singleScan(ptr_hostent)){
	printf( "\nFound possible exploit at host: %s",ptr_hostent->h_name);
      }else if(connection) {
	printf("\nNot vurnable....");
      }
    }
  }
  return true;
}

/***************************************************************************
 *                          SINGLE SCAN                                    *
 ***************************************************************************/

boolean singleScan(struct hostent* ptr_hostent){
  char cfbuff[1024];
  int index              = 0;
  char* found_msg        = "200";
  char* cgi_str          = NULL;
  socket_descriptor      = 0;

  memset((char*) &s_in,0,sizeof(s_in));
  memcpy(&s_in.sin_addr,ptr_hostent->h_addr,ptr_hostent->h_length);
  s_in.sin_family=AF_INET;
  s_in.sin_port=htons(80);

  memset((char*)&destdotaddr,0,sizeof(destdotaddr));
  destdotaddr = inet_ntoa(s_in.sin_addr);
  socket_descriptor = socket(AF_INET, SOCK_STREAM, 0);
  alarm(TIMEOUT);
  signal(SIGALRM,(void*)alert);
  if (connect(socket_descriptor, (struct sockaddr*)&s_in, sizeof(s_in))!=0){
    printf("\nConnection to host: %s:80 failed!",ptr_hostent->h_name);
    connection = false;
    return false;
  }
  alarm(60);
  printf("\n%s connected.....Searching for: %s ....", ptr_hostent->h_name, EXPLOIT_FILE);
  for(index=0;index<1024;index++){
    cfbuff[index]='\0';
  }
  send(socket_descriptor,HTTP_COMMAND, strlen(HTTP_COMMAND),0);
  recv(socket_descriptor, cfbuff, sizeof(cfbuff),0);

  cgi_str = strstr(cfbuff,found_msg);
  close(socket_descriptor);
  if( cgi_str != NULL) return true;
  else return false;
} /* EOF */

/***************************************************************************
 *                             ALERT                                       *
 ***************************************************************************/

int alert(){
 printf("\ntimeout... closing connection to: %s",inet_ntoa(s_in.sin_addr));
 close(socket_descriptor);
 return socket_descriptor;
}










